> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.awork.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.awork.com/_mcp/server.

# Updates a skill.

PUT https://api.awork.com/api/v1/agents/skills/{skillId}
Content-Type: application/json

Updates a shared skill when the caller has manage access.Any authenticated user.

Reference: https://developers.awork.com/apiv1/agent-skills/put-skills-by-skill-id

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `skillId` (string, required) — The skill ID.

### Body (application/json)

This endpoint expects an UpdateSkillRequestModel.

- `instructions` (string, required) — The Markdown instruction body from `SKILL.md`.
- `key` (string, optional, nullable) — The stable key used to reference the skill.
- `name` (string, optional, nullable) — The name shown in the skill library.
- `description` (string, optional, nullable) — A short explanation of what the skill does.
- `instructionsSource` (string, optional, nullable) — The source from which the instructions were created.
- `metadata` (string, optional, nullable) — The skill frontmatter as a JSON object.

## Response

### 200

OK

- `id` (string, optional) — The skill identifier.
- `createdBy` (string, optional) — The user who created the skill.
- `createdOn` (string, optional) — When the skill was created.
- `updatedOn` (string, optional, nullable) — When the skill was last updated.
- `key` (string, optional, nullable) — The stable key used to reference the skill.
- `name` (string, optional, nullable) — The name shown in the skill library.
- `description` (string, optional, nullable) — A short explanation of what the skill does.
- `instructions` (string, optional, nullable) — The Markdown instruction body from `SKILL.md`.
- `instructionsSource` (string, optional, nullable) — The source from which the instructions were created.
- `type` (enum, optional) — The ownership type.
  - Allowed values: `user`, `agent`
- `userId` (string, optional, nullable) — The owning user for a user-owned skill.
- `agentId` (string, optional, nullable) — The owning agent for an agent-owned skill.
- `accessLevel` (enum, optional) — The requesting user's resolved access level.
  - Allowed values: `read`, `manage`
- `isOwner` (boolean, optional) — Whether the requesting user owns the skill.
- `hasAdminAccessOnly` (boolean, optional) — Whether the skill is visible only through workspace administration access.
- `workspaceAccessLevel` (enum, optional, nullable) — The workspace-wide access level.
  - Allowed values: `read`, `manage`
- `linkedAgentCount` (integer, optional) — The number of linked agents.
- `metadata` (string, optional, nullable) — The skill frontmatter as a JSON object.
- `hasFiles` (boolean, optional) — Whether the skill includes bundled files.
- `secretRequirements` (list of SkillSecretRequirementResponseModel, optional, nullable) — The secrets that the skill declares.

## Errors

### 400 Bad Request Error

Bad Request

- `code` (string, required) — The error code.
- `description` (string, required) — The description of the error.
- `link` (string, required) — The link to the API documentation page.
- `details` (list of string, optional, nullable) — A list of details describing the error.
- `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property.
- `traceId` (string, optional, nullable) — The request trace id for tracking the request.

### 401 Unauthorized Error

Unauthorized

- `code` (string, required) — The error code.
- `description` (string, required) — The description of the error.
- `link` (string, required) — The link to the API documentation page.
- `details` (list of string, optional, nullable) — A list of details describing the error.
- `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property.
- `traceId` (string, optional, nullable) — The request trace id for tracking the request.

### 404 Not Found Error

Not Found

- `code` (string, required) — The error code.
- `description` (string, required) — The description of the error.
- `link` (string, required) — The link to the API documentation page.
- `details` (list of string, optional, nullable) — A list of details describing the error.
- `validationErrors` (list of ValidationErrorResponse, optional, nullable) — If a validation error occurred, this contains the validation errors for each property.
- `traceId` (string, optional, nullable) — The request trace id for tracking the request.

## Types

### SkillSecretRequirementResponseModel

Represents a declared secret requirement of a skill.

- `id` (string, optional) — The secret requirement identifier.
- `envVarName` (string, optional, nullable) — The environment variable name the secret is injected as.
- `description` (string, optional, nullable) — The description shown to users when providing the secret.
- `scope` (enum, optional) — Who must provide the secret value.
  - Allowed values: `workspace`, `user`
- `isRequired` (boolean, optional) — Whether the secret is required for the skill to work.
- `hasValue` (boolean, optional) — Whether a value is available for the requesting user.

### ValidationErrorResponse

The validation error response.

- `property` (string, optional, nullable) — The name of the property that failed validation.
- `message` (string, optional, nullable) — The reason why this property failed validation.

## Examples

**Request**

```json
{
  "instructions": "string"
}
```

**Response**

```json
{
  "id": "123e4567-e89b-12d3-a456-426614174000",
  "createdBy": "123e4567-e89b-12d3-a456-426614174000",
  "createdOn": "2024-01-15T09:30:00Z",
  "updatedOn": "2024-01-15T09:30:00Z",
  "key": "string",
  "name": "string",
  "description": "string",
  "instructions": "string",
  "instructionsSource": "string",
  "type": "user",
  "userId": "123e4567-e89b-12d3-a456-426614174000",
  "agentId": "123e4567-e89b-12d3-a456-426614174000",
  "accessLevel": "read",
  "isOwner": true,
  "hasAdminAccessOnly": false,
  "workspaceAccessLevel": "read",
  "linkedAgentCount": 1,
  "metadata": "string",
  "hasFiles": true,
  "secretRequirements": [
    {
      "id": "123e4567-e89b-12d3-a456-426614174000",
      "envVarName": "string",
      "description": "string",
      "scope": "workspace",
      "isRequired": true,
      "hasValue": true
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.awork.com/api/v1/agents/skills/skillId"

payload = { "instructions": "string" }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.awork.com/api/v1/agents/skills/skillId';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"instructions":"string"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.awork.com/api/v1/agents/skills/skillId"

	payload := strings.NewReader("{\n  \"instructions\": \"string\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.awork.com/api/v1/agents/skills/skillId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"instructions\": \"string\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.awork.com/api/v1/agents/skills/skillId")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"instructions\": \"string\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.awork.com/api/v1/agents/skills/skillId', [
  'body' => '{
  "instructions": "string"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.awork.com/api/v1/agents/skills/skillId");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"instructions\": \"string\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["instructions": "string"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.awork.com/api/v1/agents/skills/skillId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```